#ifndef LidarPerception_GENERAL_WRAPPER_HEADER_H
#define LidarPerception_GENERAL_WRAPPER_HEADER_H


// #include "ara/log/logging.h"
#include "lidar_perception/executable.h"
#include "sub/SubWrapperHelper.h"
#include "pub/PubWrapperHelper.h"
#include "ara/exec/execution_client.h"
#include "LidarPerception_PubDataWrapper.h"
#include "LidarPerception_SubDataWrapper.h"

using namespace jac::ap::lidarperceptionservice::skeleton;
using namespace jac::ap::hesairightlidarservice::proxy;
using namespace jac::ap::hesaileftlidarservice::proxy;
using namespace jac::ap::innolidarservice::proxy;
using namespace jac::ap::canservice::proxy;
using namespace jac::ap::slamservice::proxy;
using namespace jac::ap::vedservice::proxy;

//PubWrappers
GENERATE_PUB_WRAPPER(LiDARPerception2Fusion_Provide, LiDARPerception2Fusion_PubDataWrapper, LiDARPerceptionServiceSkeleton, perception::vector_LiDARPerception2Fusion, LiDARPerception2FusionEvent);

//SubWrappers
GENERATE_SUB_WRAPPER(LiDAR2LiDARPerception_Required, LiDAR2LiDARPerception_SubDataWrapper, InnoLiDARServiceProxy, perception::LiDAR2LiDARPerception, InnoLiDAR2LiDARPerceptionEvent, "20", 10);
GENERATE_SUB_WRAPPER(HesaiRight_Required, HesaiRight_SubDataWrapper, HesaiRightLiDARServiceProxy, perception::LiDAR2LiDARPerception, HesaiRightLiDAR2LiDARPerceptionEvent, "21", 10);
GENERATE_SUB_WRAPPER(HesaiLeft_Required, HesaiLeft_SubDataWrapper, HesaiLeftLiDARServiceProxy, perception::LiDAR2LiDARPerception, HesaiLeftLiDAR2LiDARPerceptionEvent, "22", 10);
GENERATE_SUB_WRAPPER(SLAMLocalEgoOdom2SWC_Required, SLAMLocalEgoOdom2SWC_SubDataWrapper, SLAMServiceProxy, dpc::SLAMLocalEgoOdom, SLAMLocalEgoOdomEvent, "8", 10);
GENERATE_SUB_WRAPPER(VED2LiDARPerception_Required, VED2LiDARPerception_SubDataWrapper, VEDServiceProxy, dpc::VED4FusionEgoMotion, VED2FusionEgoMotionEvent, "11", 10);

GENERATE_SUB_WRAPPER(INS_CAN2SWC_100HZ_2SWC_Required, INS_CAN2SWC_100HZ_2SWC_SubDataWrapper, CANServiceProxy, INS_CAN2SWC_100HZ, INS_CAN2SWC_100HZ_Event, "3", 10);
GENERATE_SUB_WRAPPER(IMU_CAN2SWC_100HZ_2SWC_Required, IMU_CAN2SWC_100HZ_2SWC_SubDataWrapper, CANServiceProxy, IMU_CAN2SWC_100HZ, IMU_CAN2SWC_100HZ_Event, "3", 10);

class GeneralWrapper{
public:

    //Provides
	LiDARPerception2Fusion_Provide _LiDARPerception2Fusion_Provide;

    //Requireds
    LiDAR2LiDARPerception_Required _LiDAR2LiDARPerception_Required;
    HesaiRight_Required _HesaiRight_Required;
    HesaiLeft_Required _HesaiLeft_Required;
    SLAMLocalEgoOdom2SWC_Required _SLAMLocalEgoOdom2SWC_Required;
    VED2LiDARPerception_Required _VED2LiDARPerception_Required;
    INS_CAN2SWC_100HZ_2SWC_Required _INS_CAN2SWC_100HZ_2SWC_Required;
    IMU_CAN2SWC_100HZ_2SWC_Required _IMU_CAN2SWC_100HZ_2SWC_Required;

    GeneralWrapper(nullptr);
    ~GeneralWrapper();
};


#endif //LidarPerception_GENERAL_WRAPPER_HEADER_H
